Notus API
User operations

Create Custom User Operation

Enables you to create custom user operations with full control over transaction parameters. User Operations are the transaction format used in Account Abstraction, they are blockchain transactions executed through smart wallets. This endpoint allows you to execute any smart contract function, transfer native tokens, or perform complex operations by defining your own method signatures, call data, and more.

POST
/api/v1/crypto/custom-user-operation

Authorization

x-api-key
x-api-key<token>

In: header

Request Body

application/json

TypeScript Definitions

Use the request body type in TypeScript.

Response Body

application/json

curl -X POST "https://example.com/api/v1/crypto/custom-user-operation" \  -H "Content-Type: application/json" \  -d '{    "chainId": 42161,    "operations": [      {        "address": "0x1bfd67037b42cf73acf2047067bd4f2c47d9bfd6",        "value": "10000000000000000000"      }    ],    "walletAddress": "0x6e397ddf51d9f15dbe0414538e7529f51f2e5464"  }'
{  "userOperation": {    "metadata": {      "key": "value"    },    "revertReason": {      "decoded": "ERC-20 insufficient balance. Address 0xf12534a4939c7fbda50f893774a9525265fe1a9a has 120. The operation requested 200.",      "raw": "0xe450d38c000000000000000000000000f12534a4939c7fbda50f893774a9525265fe1a9a0000000000000000000000000000000000000000000000068155a43676e0000000000000000000000000000000000000000000000000000ad78ebc5ac6200000",      "utf8": "\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000�%4�����\u000f�7t�RRe�\u001a�\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0006�U�6v�\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\u0000\n׎�Z� \u0000\u0000"    },    "authorization": {      "chainId": 42161,      "address": "0xd6cedde84be40893d153be9d467cd6ad37875b28",      "nonce": 10,      "hash": "0x777811ae5d51875409b9978ddc1b40a9da1bbe9570040bdd7c5f186d70ceceba"    },    "chainIn": {      "id": 137,      "name": "POLYGON",      "logo": "https://logopolygon.com"    },    "chainOut": {      "id": 137,      "name": "POLYGON",      "logo": "https://logopolygon.com"    },    "chainIdIn": 1,    "chainIdOut": 137,    "sender": {      "walletAddress": "0x1234567890abcdef1234567890abcdef12345678",      "accountAbstraction": "0x1234567890abcdef1234567890abcdef12345678",      "externallyOwnedAccount": "0x1234567890abcdef1234567890abcdef12345678"    },    "nonce": "1",    "signature": "0x1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef",    "callGasLimit": "100000",    "verificationGasLimit": "50000",    "preVerificationGas": "21000",    "maxFeePerGas": "20000000000",    "maxPriorityFeePerGas": "1500000000",    "maxGasFeeNative": "0.01",    "maxGasFeeToken": "0.5",    "payFeesToken": "0xabcdef1234567890abcdef1234567890abcdef12",    "factory": {      "data": "0x1234567890abcdef",      "address": "0x1234567890abcdef1234567890abcdef12345678",      "entryPointVersion": "v0.6"    },    "paymaster": "0xabcdef1234567890abcdef1234567890abcdef12",    "paymasterData": "0x1234567890abcdef1234567890abcdef",    "paymasterPostOpGasLimit": "30000",    "paymasterVerificationGasLimit": "40000",    "expiresAt": "2023-12-31T23:59:59.999Z",    "projectId": "123e4567-e89b-12d3-a456-426614174000",    "organizationId": "123e4567-e89b-12d3-a456-426614174000",    "id": "123e4567-e89b-12d3-a456-426614174000",    "userOperationHash": "0x1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef",    "hash": "0x1234567890abcdef1234567890abcdef1234567890abcdef1234567890abcdef"  }}